hdu 2227(dp+树状数组)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2227

Find the nondecreasing subsequences

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1466    Accepted Submission(s): 521

Problem Description

How many nondecreasing subsequences can you find in the sequence S = {s1, s2, s3, ...., sn} ? For example, we assume that S = {1, 2, 3}, and you can find seven nondecreasing subsequences, {1}, {2}, {3}, {1, 2}, {1, 3}, {2, 3}, {1,
2, 3}.

Input

The input consists of multiple test cases. Each case begins with a line containing a positive integer n that is the length of the sequence S, the next line contains n integers {s1, s2, s3, ...., sn}, 1 <= n <= 100000, 0 <= si <= 2^31.

Output

For each test case, output one line containing the number of nondecreasing subsequences you can find from the sequence S, the answer should % 1000000007.

Sample Input

3
1 2 3

Sample Output

7

Author

8600

思路:dp[i] 表示以第i个数为结尾的不递减子序列的个数;

那么状态转移方程式:dp[i]=sum( dp[k] ) +1;  其中a[i]>a[k]&&k<i; 这个应该好想

最朴素的方法是O(n*n),但是在这题中n的数据太大,会超时,所以再想到树状数组动态维护一段区间的和,所以先把n个数离散化一下,然后再树状数组求和;

PS:另外再说两点 (1)这题和hdu4991类似;都是dp+离散化+树状数组

(2)说实话,这题题意不明确,我都想了半天,举个例子

INPUT: 3

1 1 2

OUTPUT: 7

按AC程序:不递减子序列有7个分别为: (1),(1,1),(1),(2),(1,2),(1,2),(1,1,2),按题目的意思是对重复的组合也得算进去,这地方有点坑;

#include <iostream>
#include <stdio.h>
#include <memory.h>
#include <algorithm>
const int mod=1000000007;
using namespace std;

struct node
{
    int val, id;
}a[100005];

bool cmp(node a, node b)
{
    return a.val < b.val;
}

int b[100005], c[100005], s[100005],dp[100005],n;

int lowbit(int i)
{
    return i&(-i);
}

void update(int i, int x)
{
    while(i <= n)
    {
        s[i] += x;
        if(s[i] >= mod)
            s[i] %= 1000000007;
        i += lowbit(i);
    }
}

int getsum(int i)
{
    int sum = 0;
    while(i > 0)
    {
        sum += s[i];
        if(sum >= 1000000007)
            sum %= 1000000007;
        i -= lowbit(i);
    }
    return sum;
}

int main()
{

    while(scanf("%d", &n) != EOF)
    {
        memset(b, 0, sizeof(b));
        memset(s, 0, sizeof(s));
        memset(c,0,sizeof(c));

        for(int i = 1; i <= n; i++)
        {
            scanf("%d", &a[i].val);
            a[i].id = i;
        }
        sort(a+1, a+n+1, cmp);
        b[a[1].id] = 1;

        for(int i = 2; i <= n; i++)
        {
            if(a[i].val != a[i-1].val)
                b[a[i].id] = i;
            else b[a[i].id] = b[a[i-1].id];
        }

        for(int i=1;i<=100005;i++)dp[i]=1;

        for(int i=1;i<=n;i++)
        {
          dp[i]=dp[i]+getsum(b[i]);
          update(b[i],dp[i]);
        }

        int ans=0;
        for(int i=1;i<=n;i++)
         ans=(ans+dp[i])%mod;

        printf("%d\n",ans);
        /*res = 0;                      //两种写法
        for(i = 1; i <= n; i++)
        {
            c[i] = sum(b[i]);
            update(b[i], c[i]+1);
        }
        printf("%d\n", sum(n));
       */
    }

    return 0;
}
时间: 2024-11-09 17:03:48

hdu 2227(dp+树状数组)的相关文章

hdu 2227 dp+树状数组优化

很容易可以想到状态转移方程: dp[i] = segma: dp[j] ( j < i && a[j] <= a[i] ), 其中dp[i]表示以a[i]结尾的不降子序列的个数. 但是n非常大,n^2的算法必然TLE,仔细想想其实式子右边是一个区间和的形式,即小于等于a[i]的a[j]的dp[j]的和,所以可以将a[i]离散化成t后将dp[i]的值存在t位置上,每次求解dp[i]就是查询一个前缀和,可以用树状数组来维护. 举个例子:对于1,50,13,34这四个数,离散化后变成

HDU 2838 (DP+树状数组维护带权排序)

Reference: http://blog.csdn.net/me4546/article/details/6333225 题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=2838 题目大意:每头牛有个愤怒值,每次交换相邻两个数进行升序排序,$cost=val_{1}+val_{2}$,求$\min \sum cost_{i}$ 解题思路: 按输入顺序DP: 第i的值val的最小cost=当前数的逆序数个数*val+当前数的逆序数和 相当于每次只

HDU 2227 Find the nondecreasing subsequences (DP+树状数组+离散化)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2227 Find the nondecreasing subsequences                                  Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)                                             

树形DP+树状数组 HDU 5877 Weak Pair

1 //树形DP+树状数组 HDU 5877 Weak Pair 2 // 思路:用树状数组每次加k/a[i],每个节点ans+=Sum(a[i]) 表示每次加大于等于a[i]的值 3 // 这道题要离散化 4 5 #include <bits/stdc++.h> 6 using namespace std; 7 #define LL long long 8 typedef pair<int,int> pii; 9 const double inf = 12345678901234

HDU Cow Sorting (树状数组)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2838 Cow Sorting Problem Description Sherlock's N (1 ≤ N ≤ 100,000) cows are lined up to be milked in the evening. Each cow has a unique "grumpiness" level in the range 1...100,000. Since grumpy cow

poj 3616 Milking Time dp+树状数组

题意: 给一堆区间,每个区间有开始时间s,结束时间e,和收益w,现在要找一些区间使收益和最大,且区间之间的间隔最小为r. 分析: 这道题用dp做是简单题,用dp+树状数组做是中等题.dp问题的关键是对状态的定义.有两种方法,一:dp[k]表示按开始时间排序到第k个区间能取得的最大收益.二:dp[t]表示在时间t时能获得的最大收益.定义好状态方程就好写了这不再赘述.有趣的是这个时间复杂度.设一共有M个区间,所有区间的最大时间为L,第一种是M^2的,第二种是M*(logL+logM)的,这题M才10

hdu 5193 分块 树状数组 逆序对

题意: 给出n个数,a1,a2,a3,...,an,给出m个修改,每个修改往数组的某个位置后面插入一个数,或者把某个位置上的数移除.求每次修改后逆序对的个数. 限制: 1 <= n,m <= 20000; 1 <= ai <= n 思路: 插入和删除用分块来处理,块与块之间用双向链表来维护,每一块用树状数组来求小于某个数的数有多少个. 外层可以使用分块维护下标,这样添加和删除元素的时候,也很方便,直接暴力.查找权值个数时,使用树状数组比较方便.内层通过树状数组维护权值. 每次更新即

奶牛抗议 DP 树状数组

奶牛抗议 DP 树状数组 USACO的题太猛了 容易想到\(DP\),设\(f[i]\)表示为在第\(i\)位时方案数,转移方程: \[ f[i]=\sum f[j]\;(j< i,sum[i]-sum[j]\ge0) \] \(O(n^2)\)过不了,考虑优化 移项得: \[ f[i]=\sum f[j]\;(j< i,sum[i]\ge sum[j]) \] 这时候我们发现相当于求在\(i\)前面并且前缀和小于\(sum[i]\)的所有和,这就可以用一个树状数组优化了,在树状数组维护下标为

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include